Unit Dolphin;

{**
 * (c) Copyright 1993, 1994, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Silicon Graphics, Inc. not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * US Government Users Restricted Rights
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 *
}

Interface

Uses AtBase,OpenGL;

Procedure DrawDolphin(Var fish:fishRec);

Implementation

Const
     N001:Array[0..2] Of Single = (-0.005937 ,-0.101998 ,-0.994767);
     N002:Array[0..2] Of Single = (0.936780 ,-0.200803 ,0.286569);
     N003:Array[0..2] Of Single = (-0.233062 ,0.972058 ,0.028007);
     N004:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N005:Array[0..2] Of Single = (0.898117 ,0.360171 ,0.252315);
     N006:Array[0..2] Of Single = (-0.915437 ,0.348456 ,0.201378);
     N007:Array[0..2] Of Single = (0.602263 ,-0.777527 ,0.180920);
     N008:Array[0..2] Of Single = (-0.906912 ,-0.412015 ,0.088061);
     N009:Array[0..2] Of Single = (-0.015623 ,0.999878 ,0.000000);
     N010:Array[0..2] Of Single = (0.000000 ,-0.992278 ,0.124035);
     N011:Array[0..2] Of Single = (0.000000 ,-0.936329 ,-0.351123);
     N012:Array[0..2] Of Single = (0.884408 ,-0.429417 ,-0.182821);
     N013:Array[0..2] Of Single = (0.921121 ,0.311084 ,-0.234016);
     N014:Array[0..2] Of Single = (0.382635 ,0.877882 ,-0.287948);
     N015:Array[0..2] Of Single = (-0.380046 ,0.888166 ,-0.258316);
     N016:Array[0..2] Of Single = (-0.891515 ,0.392238 ,-0.226607);
     N017:Array[0..2] Of Single = (-0.901419 ,-0.382002 ,-0.203763);
     N018:Array[0..2] Of Single = (-0.367225 ,-0.911091 ,-0.187243);
     N019:Array[0..2] Of Single = (0.339539 ,-0.924846 ,-0.171388);
     N020:Array[0..2] Of Single = (0.914706 ,-0.378617 ,-0.141290);
     N021:Array[0..2] Of Single = (0.950662 ,0.262713 ,-0.164994);
     N022:Array[0..2] Of Single = (0.546359 ,0.801460 ,-0.243218);
     N023:Array[0..2] Of Single = (-0.315796 ,0.917068 ,-0.243431);
     N024:Array[0..2] Of Single = (-0.825687 ,0.532277 ,-0.186875);
     N025:Array[0..2] Of Single = (-0.974763 ,-0.155232 ,-0.160435);
     N026:Array[0..2] Of Single = (-0.560596 ,-0.816658 ,-0.137119);
     N027:Array[0..2] Of Single = (0.380210 ,-0.910817 ,-0.160786);
     N028:Array[0..2] Of Single = (0.923772 ,-0.358322 ,-0.135093);
     N029:Array[0..2] Of Single = (0.951202 ,0.275053 ,-0.139859);
     N030:Array[0..2] Of Single = (0.686099 ,0.702548 ,-0.188932);
     N031:Array[0..2] Of Single = (-0.521865 ,0.826719 ,-0.210220);
     N032:Array[0..2] Of Single = (-0.923820 ,0.346739 ,-0.162258);
     N033:Array[0..2] Of Single = (-0.902095 ,-0.409995 ,-0.134646);
     N034:Array[0..2] Of Single = (-0.509115 ,-0.848498 ,-0.144404);
     N035:Array[0..2] Of Single = (0.456469 ,-0.880293 ,-0.129305);
     N036:Array[0..2] Of Single = (0.873401 ,-0.475489 ,-0.105266);
     N037:Array[0..2] Of Single = (0.970825 ,0.179861 ,-0.158584);
     N038:Array[0..2] Of Single = (0.675609 ,0.714187 ,-0.183004);
     N039:Array[0..2] Of Single = (-0.523574 ,0.830212 ,-0.191360);
     N040:Array[0..2] Of Single = (-0.958895 ,0.230808 ,-0.165071);
     N041:Array[0..2] Of Single = (-0.918285 ,-0.376803 ,-0.121542);
     N042:Array[0..2] Of Single = (-0.622467 ,-0.774167 ,-0.114888);
     N043:Array[0..2] Of Single = (0.404497 ,-0.908807 ,-0.102231);
     N044:Array[0..2] Of Single = (0.930538 ,-0.365155 ,-0.027588);
     N045:Array[0..2] Of Single = (0.921920 ,0.374157 ,-0.100345);
     N046:Array[0..2] Of Single = (0.507346 ,0.860739 ,0.041562);
     N047:Array[0..2] Of Single = (-0.394646 ,0.918815 ,-0.005730);
     N048:Array[0..2] Of Single = (-0.925411 ,0.373024 ,-0.066837);
     N049:Array[0..2] Of Single = (-0.945337 ,-0.322309 ,-0.049551);
     N050:Array[0..2] Of Single = (-0.660437 ,-0.750557 ,-0.022072);
     N051:Array[0..2] Of Single = (0.488835 ,-0.871950 ,-0.027261);
     N052:Array[0..2] Of Single = (0.902599 ,-0.421397 ,0.087969);
     N053:Array[0..2] Of Single = (0.938636 ,0.322606 ,0.122020);
     N054:Array[0..2] Of Single = (0.484605 ,0.871078 ,0.079878);
     N055:Array[0..2] Of Single = (-0.353607 ,0.931559 ,0.084619);
     N056:Array[0..2] Of Single = (-0.867759 ,0.478564 ,0.134054);
     N057:Array[0..2] Of Single = (-0.951583 ,-0.296030 ,0.082794);
     N058:Array[0..2] Of Single = (-0.672355 ,-0.730209 ,0.121384);
     N059:Array[0..2] Of Single = (0.528336 ,-0.842452 ,0.105525);
     N060:Array[0..2] Of Single = (0.786913 ,-0.564760 ,0.248627);
     N061:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N062:Array[0..2] Of Single = (0.622098 ,0.765230 ,0.165584);
     N063:Array[0..2] Of Single = (-0.631711 ,0.767816 ,0.106773);
     N064:Array[0..2] Of Single = (-0.687886 ,0.606351 ,0.398938);
     N065:Array[0..2] Of Single = (-0.946327 ,-0.281623 ,0.158598);
     N066:Array[0..2] Of Single = (-0.509549 ,-0.860437 ,0.002776);
     N067:Array[0..2] Of Single = (0.462594 ,-0.876692 ,0.131977);
     N068:Array[0..2] Of Single = (0.000000 ,-0.992278 ,0.124035);
     N069:Array[0..2] Of Single = (0.000000 ,-0.970143 ,-0.242536);
     N070:Array[0..2] Of Single = (0.015502 ,0.992159 ,-0.124020);
     N071:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N072:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N073:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N074:Array[0..2] Of Single = (0.000000 ,-1.000000 ,0.000000);
     N075:Array[0..2] Of Single = (-0.242536 ,0.000000 ,-0.970143);
     N076:Array[0..2] Of Single = (-0.010336 ,-0.992225 ,-0.124028);
     N077:Array[0..2] Of Single = (-0.880770 ,0.461448 ,0.106351);
     N078:Array[0..2] Of Single = (-0.880770 ,0.461448 ,0.106351);
     N079:Array[0..2] Of Single = (-0.880770 ,0.461448 ,0.106351);
     N080:Array[0..2] Of Single = (-0.880770 ,0.461448 ,0.106351);
     N081:Array[0..2] Of Single = (-0.571197 ,0.816173 ,0.087152);
     N082:Array[0..2] Of Single = (-0.880770 ,0.461448 ,0.106351);
     N083:Array[0..2] Of Single = (-0.571197 ,0.816173 ,0.087152);
     N084:Array[0..2] Of Single = (-0.571197 ,0.816173 ,0.087152);
     N085:Array[0..2] Of Single = (-0.880770 ,0.461448 ,0.106351);
     N086:Array[0..2] Of Single = (-0.571197 ,0.816173 ,0.087152);
     N087:Array[0..2] Of Single = (-0.880770 ,0.461448 ,0.106351);
     N088:Array[0..2] Of Single = (-0.880770 ,0.461448 ,0.106351);
     N089:Array[0..2] Of Single = (-0.880770 ,0.461448 ,0.106351);
     N090:Array[0..2] Of Single = (-0.880770 ,0.461448 ,0.106351);
     N091:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N092:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N093:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N094:Array[0..2] Of Single = (1.000000 ,0.000000 ,0.000000);
     N095:Array[0..2] Of Single = (-1.000000 ,0.000000 ,0.000000);
     N096:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N097:Array[0..2] Of Single = (-0.697296 ,0.702881 ,0.140491);
     N098:Array[0..2] Of Single = (0.918864 ,0.340821 ,0.198819);
     N099:Array[0..2] Of Single = (-0.932737 ,0.201195 ,0.299202);
     N100:Array[0..2] Of Single = (0.029517 ,0.981679 ,0.188244);
     N101:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N102:Array[0..2] Of Single = (0.813521 ,-0.204936 ,0.544229);
     N103:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N104:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N105:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N106:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N107:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N108:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N109:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N110:Array[0..2] Of Single = (-0.781480 ,-0.384779 ,0.491155);
     N111:Array[0..2] Of Single = (-0.722243 ,0.384927 ,0.574627);
     N112:Array[0..2] Of Single = (-0.752278 ,0.502679 ,0.425901);
     N113:Array[0..2] Of Single = (0.547257 ,0.367910 ,0.751766);
     N114:Array[0..2] Of Single = (0.725949 ,-0.232568 ,0.647233);
     N115:Array[0..2] Of Single = (-0.747182 ,-0.660786 ,0.071280);
     N116:Array[0..2] Of Single = (0.931519 ,0.200748 ,0.303270);
     N117:Array[0..2] Of Single = (-0.828928 ,0.313757 ,0.463071);
     N118:Array[0..2] Of Single = (0.902554 ,-0.370967 ,0.218587);
     N119:Array[0..2] Of Single = (-0.879257 ,-0.441851 ,0.177973);
     N120:Array[0..2] Of Single = (0.642327 ,0.611901 ,0.461512);
     N121:Array[0..2] Of Single = (0.964817 ,-0.202322 ,0.167910);
     N122:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N123:Array[0..2] Of Single = (-0.980734 ,0.041447 ,0.190900);
     N124:Array[0..2] Of Single = (-0.980734 ,0.041447 ,0.190900);
     N125:Array[0..2] Of Single = (-0.980734 ,0.041447 ,0.190900);
     N126:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N127:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N128:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N129:Array[0..2] Of Single = (0.963250 ,0.004839 ,0.268565);
     N130:Array[0..2] Of Single = (0.963250 ,0.004839 ,0.268565);
     N131:Array[0..2] Of Single = (0.963250 ,0.004839 ,0.268565);
     N132:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N133:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     N134:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
     P001:Array[0..2] Of Single = (5.68, -300.95, 1324.70);
     P002:Array[0..2] Of Single = (338.69, -219.63, 9677.03);
     P003:Array[0..2] Of Single = (12.18, 474.59, 9138.14);
     P004:Array[0..2] Of Single = (-7.49, -388.91, 10896.74);
     P005:Array[0..2] Of Single = (487.51, 198.05, 9350.78);
     P006:Array[0..2] Of Single = (-457.61, 68.74, 9427.85);
     P007:Array[0..2] Of Single = (156.52, -266.72, 10311.68);
     P008:Array[0..2] Of Single = (-185.56, -266.51, 10310.47);
     P009:Array[0..2] Of Single = (124.39, -261.46, 1942.34);
     P010:Array[0..2] Of Single = (-130.05, -261.46, 1946.03);
     P011:Array[0..2] Of Single = (141.07, -320.11, 1239.38);
     P012:Array[0..2] Of Single = (156.48, -360.12, 2073.41);
     P013:Array[0..2] Of Single = (162.00, -175.88, 2064.44);
     P014:Array[0..2] Of Single = (88.16, -87.72, 2064.02);
     P015:Array[0..2] Of Single = (-65.21, -96.13, 2064.02);
     P016:Array[0..2] Of Single = (-156.48, -180.96, 2064.44);
     P017:Array[0..2] Of Single = (-162.00, -368.93, 2082.39);
     P018:Array[0..2] Of Single = (-88.16, -439.22, 2082.39);
     P019:Array[0..2] Of Single = (65.21, -440.32, 2083.39);
     P020:Array[0..2] Of Single = (246.87, -356.02, 2576.95);
     P021:Array[0..2] Of Single = (253.17, -111.15, 2567.15);
     P022:Array[0..2] Of Single = (132.34, 51.41, 2559.84);
     P023:Array[0..2] Of Single = (-97.88, 40.44, 2567.15);
     P024:Array[0..2] Of Single = (-222.97, -117.49, 2567.15);
     P025:Array[0..2] Of Single = (-252.22, -371.53, 2569.92);
     P026:Array[0..2] Of Single = (-108.44, -518.19, 2586.75);
     P027:Array[0..2] Of Single = (97.88, -524.79, 2586.75);
     P028:Array[0..2] Of Single = (370.03, -421.19, 3419.70);
     P029:Array[0..2] Of Single = (351.15, -16.98, 3423.17);
     P030:Array[0..2] Of Single = (200.66, 248.46, 3430.37);
     P031:Array[0..2] Of Single = (-148.42, 235.02, 3417.91);
     P032:Array[0..2] Of Single = (-360.21, -30.27, 3416.84);
     P033:Array[0..2] Of Single = (-357.90, -414.89, 3407.04);
     P034:Array[0..2] Of Single = (-148.88, -631.35, 3409.90);
     P035:Array[0..2] Of Single = (156.38, -632.59, 3419.70);
     P036:Array[0..2] Of Single = (462.61, -469.21, 4431.51);
     P037:Array[0..2] Of Single = (466.60, 102.25, 4434.98);
     P038:Array[0..2] Of Single = (243.05, 474.34, 4562.02);
     P039:Array[0..2] Of Single = (-191.23, 474.40, 4554.42);
     P040:Array[0..2] Of Single = (-476.12, 111.05, 4451.11);
     P041:Array[0..2] Of Single = (-473.36, -470.74, 4444.78);
     P042:Array[0..2] Of Single = (-266.95, -748.41, 4447.78);
     P043:Array[0..2] Of Single = (211.14, -749.91, 4429.73);
     P044:Array[0..2] Of Single = (680.57, -370.27, 5943.46);
     P045:Array[0..2] Of Single = (834.01, 363.09, 6360.63);
     P046:Array[0..2] Of Single = (371.29, 804.51, 6486.26);
     P047:Array[0..2] Of Single = (-291.43, 797.22, 6494.28);
     P048:Array[0..2] Of Single = (-784.13, 370.75, 6378.01);
     P049:Array[0..2] Of Single = (-743.29, -325.82, 5943.46);
     P050:Array[0..2] Of Single = (-383.24, -804.77, 5943.46);
     P051:Array[0..2] Of Single = (283.47, -846.09, 5943.46);
     iP001:Array[0..2] Of Single = (5.68, -300.95, 1324.70);
     iP002:Array[0..2] Of Single = (338.69, -219.63, 9677.03);
     iP003:Array[0..2] Of Single = (12.18, 624.93, 8956.39);
     iP004:Array[0..2] Of Single = (-7.49, -388.91, 10896.74);
     iP005:Array[0..2] Of Single = (487.51, 198.05, 9350.78);
     iP006:Array[0..2] Of Single = (-457.61, 199.04, 9353.01);
     iP007:Array[0..2] Of Single = (156.52, -266.72, 10311.68);
     iP008:Array[0..2] Of Single = (-185.56, -266.51, 10310.47);
     iP009:Array[0..2] Of Single = (124.39, -261.46, 1942.34);
     iP010:Array[0..2] Of Single = (-130.05, -261.46, 1946.03);
     iP011:Array[0..2] Of Single = (141.07, -320.11, 1239.38);
     iP012:Array[0..2] Of Single = (156.48, -360.12, 2073.41);
     iP013:Array[0..2] Of Single = (162.00, -175.88, 2064.44);
     iP014:Array[0..2] Of Single = (88.16, -87.72, 2064.02);
     iP015:Array[0..2] Of Single = (-65.21, -96.13, 2064.02);
     iP016:Array[0..2] Of Single = (-156.48, -180.96, 2064.44);
     iP017:Array[0..2] Of Single = (-162.00, -368.93, 2082.39);
     iP018:Array[0..2] Of Single = (-88.16, -439.22, 2082.39);
     iP019:Array[0..2] Of Single = (65.21, -440.32, 2083.39);
     iP020:Array[0..2] Of Single = (246.87, -356.02, 2576.95);
     iP021:Array[0..2] Of Single = (253.17, -111.15, 2567.15);
     iP022:Array[0..2] Of Single = (132.34, 51.41, 2559.84);
     iP023:Array[0..2] Of Single = (-97.88, 40.44, 2567.15);
     iP024:Array[0..2] Of Single = (-222.97, -117.49, 2567.15);
     iP025:Array[0..2] Of Single = (-252.22, -371.53, 2569.92);
     iP026:Array[0..2] Of Single = (-108.44, -518.19, 2586.75);
     iP027:Array[0..2] Of Single = (97.88, -524.79, 2586.75);
     iP028:Array[0..2] Of Single = (370.03, -421.19, 3419.70);
     iP029:Array[0..2] Of Single = (351.15, -16.98, 3423.17);
     iP030:Array[0..2] Of Single = (200.66, 248.46, 3430.37);
     iP031:Array[0..2] Of Single = (-148.42, 235.02, 3417.91);
     iP032:Array[0..2] Of Single = (-360.21, -30.27, 3416.84);
     iP033:Array[0..2] Of Single = (-357.90, -414.89, 3407.04);
     iP034:Array[0..2] Of Single = (-148.88, -631.35, 3409.90);
     iP035:Array[0..2] Of Single = (156.38, -632.59, 3419.70);
     iP036:Array[0..2] Of Single = (462.61, -469.21, 4431.51);
     iP037:Array[0..2] Of Single = (466.60, 102.25, 4434.98);
     iP038:Array[0..2] Of Single = (243.05, 474.34, 4562.02);
     iP039:Array[0..2] Of Single = (-191.23, 474.40, 4554.42);
     iP040:Array[0..2] Of Single = (-476.12, 111.05, 4451.11);
     iP041:Array[0..2] Of Single = (-473.36, -470.74, 4444.78);
     iP042:Array[0..2] Of Single = (-266.95, -748.41, 4447.78);
     iP043:Array[0..2] Of Single = (211.14, -749.91, 4429.73);
     iP044:Array[0..2] Of Single = (680.57, -370.27, 5943.46);
     iP045:Array[0..2] Of Single = (834.01, 363.09, 6360.63);
     iP046:Array[0..2] Of Single = (371.29, 804.51, 6486.26);
     iP047:Array[0..2] Of Single = (-291.43, 797.22, 6494.28);
     iP048:Array[0..2] Of Single = (-784.13, 370.75, 6378.01);
     iP049:Array[0..2] Of Single = (-743.29, -325.82, 5943.46);
     iP050:Array[0..2] Of Single = (-383.24, -804.77, 5943.46);
     iP051:Array[0..2] Of Single = (283.47, -846.09, 5943.46);
     P052:Array[0..2] Of Single = (599.09, -300.15, 7894.03);
     P053:Array[0..2] Of Single = (735.48, 306.26, 7911.92);
     P054:Array[0..2] Of Single = (246.22, 558.53, 8460.50);
     P055:Array[0..2] Of Single = (-230.41, 559.84, 8473.23);
     P056:Array[0..2] Of Single = (-698.66, 320.83, 7902.59);
     P057:Array[0..2] Of Single = (-643.29, -299.16, 7902.59);
     P058:Array[0..2] Of Single = (-341.47, -719.30, 7902.59);
     P059:Array[0..2] Of Single = (252.57, -756.12, 7902.59);
     P060:Array[0..2] Of Single = (458.39, -265.31, 9355.44);
     P061:Array[0..2] Of Single = (433.38, -161.90, 9503.03);
     P062:Array[0..2] Of Single = (224.04, 338.75, 9450.30);
     P063:Array[0..2] Of Single = (-165.71, 341.04, 9462.35);
     P064:Array[0..2] Of Single = (-298.11, 110.13, 10180.37);
     P065:Array[0..2] Of Single = (-473.99, -219.71, 9355.44);
     P066:Array[0..2] Of Single = (-211.97, -479.87, 9355.44);
     P067:Array[0..2] Of Single = (192.86, -491.45, 9348.73);
     P068:Array[0..2] Of Single = (-136.29, -319.84, 1228.73);
     P069:Array[0..2] Of Single = (1111.17, -314.14, 1314.19);
     P070:Array[0..2] Of Single = (-1167.34, -321.61, 1319.45);
     P071:Array[0..2] Of Single = (1404.86, -306.66, 1235.45);
     P072:Array[0..2] Of Single = (-1409.73, -314.14, 1247.66);
     P073:Array[0..2] Of Single = (1254.01, -296.87, 1544.58);
     P074:Array[0..2] Of Single = (-1262.09, -291.70, 1504.26);
     P075:Array[0..2] Of Single = (965.71, -269.26, 1742.65);
     P076:Array[0..2] Of Single = (-900.97, -276.74, 1726.07);
     iP068:Array[0..2] Of Single = (-136.29, -319.84, 1228.73);
     iP069:Array[0..2] Of Single = (1111.17, -314.14, 1314.19);
     iP070:Array[0..2] Of Single = (-1167.34, -321.61, 1319.45);
     iP071:Array[0..2] Of Single = (1404.86, -306.66, 1235.45);
     iP072:Array[0..2] Of Single = (-1409.73, -314.14, 1247.66);
     iP073:Array[0..2] Of Single = (1254.01, -296.87, 1544.58);
     iP074:Array[0..2] Of Single = (-1262.09, -291.70, 1504.26);
     iP075:Array[0..2] Of Single = (965.71, -269.26, 1742.65);
     iP076:Array[0..2] Of Single = (-900.97, -276.74, 1726.07);
     P077:Array[0..2] Of Single = (1058.00, -448.81, 8194.66);
     P078:Array[0..2] Of Single = (-1016.51, -456.43, 8190.62);
     P079:Array[0..2] Of Single = (-1515.96, -676.45, 7754.93);
     P080:Array[0..2] Of Single = (1856.75, -830.34, 7296.56);
     P081:Array[0..2] Of Single = (1472.16, -497.38, 7399.68);
     P082:Array[0..2] Of Single = (-1775.26, -829.51, 7298.46);
     P083:Array[0..2] Of Single = (911.09, -252.51, 7510.99);
     P084:Array[0..2] Of Single = (-1451.94, -495.62, 7384.30);
     P085:Array[0..2] Of Single = (1598.75, -669.26, 7769.90);
     P086:Array[0..2] Of Single = (-836.53, -250.08, 7463.25);
     P087:Array[0..2] Of Single = (722.87, -158.18, 8006.41);
     P088:Array[0..2] Of Single = (-688.86, -162.28, 7993.89);
     P089:Array[0..2] Of Single = (-626.92, -185.30, 8364.98);
     P090:Array[0..2] Of Single = (647.72, -189.46, 8354.99);
     P091:Array[0..2] Of Single = (0.00, 835.01, 5555.62);
     P092:Array[0..2] Of Single = (0.00, 1350.18, 5220.86);
     P093:Array[0..2] Of Single = (0.00, 1422.94, 5285.27);
     P094:Array[0..2] Of Single = (0.00, 1296.75, 5650.19);
     P095:Array[0..2] Of Single = (0.00, 795.63, 6493.88);
     iP091:Array[0..2] Of Single = (0.00, 835.01, 5555.62);
     iP092:Array[0..2] Of Single = (0.00, 1350.18, 5220.86);
     iP093:Array[0..2] Of Single = (0.00, 1422.94, 5285.27);
     iP094:Array[0..2] Of Single = (0.00, 1296.75, 5650.19);
     iP095:Array[0..2] Of Single = (0.00, 795.63, 6493.88);
     P096:Array[0..2] Of Single = (-447.38, -165.99, 9499.60);
     P097:Array[0..2] Of Single = (-194.91, -357.14, 10313.32);
     P098:Array[0..2] Of Single = (135.35, -357.66, 10307.94);
     iP097:Array[0..2] Of Single = (-194.91, -357.14, 10313.32);
     iP098:Array[0..2] Of Single = (135.35, -357.66, 10307.94);
     P099:Array[0..2] Of Single = (-380.53, -221.14, 9677.98);
     P100:Array[0..2] Of Single = (0.00, 412.99, 9629.33);
     P101:Array[0..2] Of Single = (5.70, 567.00, 7862.98);
     P102:Array[0..2] Of Single = (59.51, -412.55, 10677.58);
     iP102:Array[0..2] Of Single = (59.51, -412.55, 10677.58);
     P103:Array[0..2] Of Single = (6.50, 484.74, 9009.94);
     P104:Array[0..2] Of Single = (-9.86, 567.62, 7858.65);
     P105:Array[0..2] Of Single = (-41.86, 476.51, 9078.17);
     P106:Array[0..2] Of Single = (22.75, 568.13, 7782.83);
     P107:Array[0..2] Of Single = (58.93, 568.42, 7775.94);
     P108:Array[0..2] Of Single = (49.20, 476.83, 9078.24);
     P109:Array[0..2] Of Single = (99.21, 566.00, 7858.65);
     P110:Array[0..2] Of Single = (-187.62, -410.04, 10674.12);
     iP110:Array[0..2] Of Single = (-187.62, -410.04, 10674.12);
     P111:Array[0..2] Of Single = (-184.25, -318.70, 10723.88);
     iP111:Array[0..2] Of Single = (-184.25, -318.70, 10723.88);
     P112:Array[0..2] Of Single = (-179.61, -142.81, 10670.26);
     P113:Array[0..2] Of Single = (57.43, -147.94, 10675.26);
     P114:Array[0..2] Of Single = (54.06, -218.90, 10712.44);
     P115:Array[0..2] Of Single = (-186.35, -212.09, 10713.76);
     P116:Array[0..2] Of Single = (205.90, -84.61, 10275.97);
     P117:Array[0..2] Of Single = (-230.96, -83.26, 10280.09);
     iP118:Array[0..2] Of Single = (216.78, -509.17, 10098.94);
     iP119:Array[0..2] Of Single = (-313.21, -510.79, 10102.62);
     P118:Array[0..2] Of Single = (216.78, -509.17, 10098.94);
     P119:Array[0..2] Of Single = (-313.21, -510.79, 10102.62);
     P120:Array[0..2] Of Single = (217.95, 96.34, 10161.62);
     P121:Array[0..2] Of Single = (71.99, -319.74, 10717.70);
     iP121:Array[0..2] Of Single = (71.99, -319.74, 10717.70);
     P122:Array[0..2] Of Single = (0.00, 602.74, 5375.84);
     iP122:Array[0..2] Of Single = (0.00, 602.74, 5375.84);
     P123:Array[0..2] Of Single = (-448.94, -203.14, 9499.60);
     P124:Array[0..2] Of Single = (-442.64, -185.20, 9528.07);
     P125:Array[0..2] Of Single = (-441.07, -148.05, 9528.07);
     P126:Array[0..2] Of Single = (-443.43, -128.84, 9499.60);
     P127:Array[0..2] Of Single = (-456.87, -146.78, 9466.67);
     P128:Array[0..2] Of Single = (-453.68, -183.93, 9466.67);
     P129:Array[0..2] Of Single = (428.43, -124.08, 9503.03);
     P130:Array[0..2] Of Single = (419.73, -142.14, 9534.56);
     P131:Array[0..2] Of Single = (419.92, -179.96, 9534.56);
     P132:Array[0..2] Of Single = (431.20, -199.73, 9505.26);
     P133:Array[0..2] Of Single = (442.28, -181.67, 9475.96);
     P134:Array[0..2] Of Single = (442.08, -143.84, 9475.96);

Procedure Dolphin001;
Begin
    glNormal3fv(N071);
    glBegin(GL_POLYGON);
    glVertex3fv(P001);
    glVertex3fv(P068);
    glVertex3fv(P010);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P068);
    glVertex3fv(P076);
    glVertex3fv(P010);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P068);
    glVertex3fv(P070);
    glVertex3fv(P076);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P076);
    glVertex3fv(P070);
    glVertex3fv(P074);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P070);
    glVertex3fv(P072);
    glVertex3fv(P074);
    glEnd;
    glNormal3fv(N119);
    glBegin(GL_POLYGON);
    glVertex3fv(P072);
    glVertex3fv(P070);
    glVertex3fv(P074);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P074);
    glVertex3fv(P070);
    glVertex3fv(P076);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P070);
    glVertex3fv(P068);
    glVertex3fv(P076);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P076);
    glVertex3fv(P068);
    glVertex3fv(P010);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P068);
    glVertex3fv(P001);
    glVertex3fv(P010);
    glEnd;
End;

Procedure Dolphin002;
Begin
    glNormal3fv(N071);
    glBegin(GL_POLYGON);
    glVertex3fv(P011);
    glVertex3fv(P001);
    glVertex3fv(P009);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P075);
    glVertex3fv(P011);
    glVertex3fv(P009);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P069);
    glVertex3fv(P011);
    glVertex3fv(P075);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P069);
    glVertex3fv(P075);
    glVertex3fv(P073);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P071);
    glVertex3fv(P069);
    glVertex3fv(P073);
    glEnd;
    glNormal3fv(N119);
    glBegin(GL_POLYGON);
    glVertex3fv(P001);
    glVertex3fv(P011);
    glVertex3fv(P009);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P009);
    glVertex3fv(P011);
    glVertex3fv(P075);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P011);
    glVertex3fv(P069);
    glVertex3fv(P075);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P069);
    glVertex3fv(P073);
    glVertex3fv(P075);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P069);
    glVertex3fv(P071);
    glVertex3fv(P073);
    glEnd;
End;

Procedure Dolphin003;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N018);
    glVertex3fv(P018);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N019);
    glVertex3fv(P019);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N019);
    glVertex3fv(P019);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N012);
    glVertex3fv(P012);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N017);
    glVertex3fv(P017);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N018);
    glVertex3fv(P018);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N017);
    glVertex3fv(P017);
    glNormal3fv(N016);
    glVertex3fv(P016);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N013);
    glVertex3fv(P013);
    glNormal3fv(N012);
    glVertex3fv(P012);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N016);
    glVertex3fv(P016);
    glNormal3fv(N015);
    glVertex3fv(P015);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N014);
    glVertex3fv(P014);
    glNormal3fv(N013);
    glVertex3fv(P013);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N015);
    glVertex3fv(P015);
    glNormal3fv(N014);
    glVertex3fv(P014);
    glEnd;
End;

Procedure Dolphin004;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N014);
    glVertex3fv(P014);
    glNormal3fv(N015);
    glVertex3fv(P015);
    glNormal3fv(N023);
    glVertex3fv(P023);
    glNormal3fv(N022);
    glVertex3fv(P022);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N015);
    glVertex3fv(P015);
    glNormal3fv(N016);
    glVertex3fv(P016);
    glNormal3fv(N024);
    glVertex3fv(P024);
    glNormal3fv(N023);
    glVertex3fv(P023);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N016);
    glVertex3fv(P016);
    glNormal3fv(N017);
    glVertex3fv(P017);
    glNormal3fv(N025);
    glVertex3fv(P025);
    glNormal3fv(N024);
    glVertex3fv(P024);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N017);
    glVertex3fv(P017);
    glNormal3fv(N018);
    glVertex3fv(P018);
    glNormal3fv(N026);
    glVertex3fv(P026);
    glNormal3fv(N025);
    glVertex3fv(P025);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N013);
    glVertex3fv(P013);
    glNormal3fv(N014);
    glVertex3fv(P014);
    glNormal3fv(N022);
    glVertex3fv(P022);
    glNormal3fv(N021);
    glVertex3fv(P021);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N012);
    glVertex3fv(P012);
    glNormal3fv(N013);
    glVertex3fv(P013);
    glNormal3fv(N021);
    glVertex3fv(P021);
    glNormal3fv(N020);
    glVertex3fv(P020);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N018);
    glVertex3fv(P018);
    glNormal3fv(N019);
    glVertex3fv(P019);
    glNormal3fv(N027);
    glVertex3fv(P027);
    glNormal3fv(N026);
    glVertex3fv(P026);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N019);
    glVertex3fv(P019);
    glNormal3fv(N012);
    glVertex3fv(P012);
    glNormal3fv(N020);
    glVertex3fv(P020);
    glNormal3fv(N027);
    glVertex3fv(P027);
    glEnd;
End;

Procedure Dolphin005;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N022);
    glVertex3fv(P022);
    glNormal3fv(N023);
    glVertex3fv(P023);
    glNormal3fv(N031);
    glVertex3fv(P031);
    glNormal3fv(N030);
    glVertex3fv(P030);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N021);
    glVertex3fv(P021);
    glNormal3fv(N022);
    glVertex3fv(P022);
    glNormal3fv(N030);
    glVertex3fv(P030);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N021);
    glVertex3fv(P021);
    glNormal3fv(N030);
    glVertex3fv(P030);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N023);
    glVertex3fv(P023);
    glNormal3fv(N024);
    glVertex3fv(P024);
    glNormal3fv(N031);
    glVertex3fv(P031);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N024);
    glVertex3fv(P024);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glNormal3fv(N031);
    glVertex3fv(P031);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N024);
    glVertex3fv(P024);
    glNormal3fv(N025);
    glVertex3fv(P025);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N025);
    glVertex3fv(P025);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N020);
    glVertex3fv(P020);
    glNormal3fv(N021);
    glVertex3fv(P021);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N020);
    glVertex3fv(P020);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N027);
    glVertex3fv(P027);
    glNormal3fv(N020);
    glVertex3fv(P020);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N027);
    glVertex3fv(P027);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glNormal3fv(N035);
    glVertex3fv(P035);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N025);
    glVertex3fv(P025);
    glNormal3fv(N026);
    glVertex3fv(P026);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N026);
    glVertex3fv(P026);
    glNormal3fv(N034);
    glVertex3fv(P034);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N026);
    glVertex3fv(P026);
    glNormal3fv(N027);
    glVertex3fv(P027);
    glNormal3fv(N035);
    glVertex3fv(P035);
    glNormal3fv(N034);
    glVertex3fv(P034);
    glEnd;
End;

Procedure Dolphin006;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N092);
    glVertex3fv(P092);
    glNormal3fv(N093);
    glVertex3fv(P093);
    glNormal3fv(N094);
    glVertex3fv(P094);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N093);
    glVertex3fv(P093);
    glNormal3fv(N092);
    glVertex3fv(P092);
    glNormal3fv(N094);
    glVertex3fv(P094);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N092);
    glVertex3fv(P092);
    glNormal3fv(N091);
    glVertex3fv(P091);
    glNormal3fv(N095);
    glVertex3fv(P095);
    glNormal3fv(N094);
    glVertex3fv(P094);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N091);
    glVertex3fv(P091);
    glNormal3fv(N092);
    glVertex3fv(P092);
    glNormal3fv(N094);
    glVertex3fv(P094);
    glNormal3fv(N095);
    glVertex3fv(P095);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N122);
    glVertex3fv(P122);
    glNormal3fv(N095);
    glVertex3fv(P095);
    glNormal3fv(N091);
    glVertex3fv(P091);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N122);
    glVertex3fv(P122);
    glNormal3fv(N091);
    glVertex3fv(P091);
    glNormal3fv(N095);
    glVertex3fv(P095);
    glEnd;
End;

Procedure Dolphin007;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N030);
    glVertex3fv(P030);
    glNormal3fv(N031);
    glVertex3fv(P031);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glNormal3fv(N030);
    glVertex3fv(P030);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N035);
    glVertex3fv(P035);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N035);
    glVertex3fv(P035);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glNormal3fv(N043);
    glVertex3fv(P043);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N034);
    glVertex3fv(P034);
    glNormal3fv(N035);
    glVertex3fv(P035);
    glNormal3fv(N043);
    glVertex3fv(P043);
    glNormal3fv(N042);
    glVertex3fv(P042);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N034);
    glVertex3fv(P034);
    glNormal3fv(N042);
    glVertex3fv(P042);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N042);
    glVertex3fv(P042);
    glNormal3fv(N041);
    glVertex3fv(P041);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N031);
    glVertex3fv(P031);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N041);
    glVertex3fv(P041);
    glEnd;
End;

Procedure Dolphin008;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N042);
    glVertex3fv(P042);
    glNormal3fv(N043);
    glVertex3fv(P043);
    glNormal3fv(N051);
    glVertex3fv(P051);
    glNormal3fv(N050);
    glVertex3fv(P050);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N043);
    glVertex3fv(P043);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glNormal3fv(N051);
    glVertex3fv(P051);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N051);
    glVertex3fv(P051);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N041);
    glVertex3fv(P041);
    glNormal3fv(N042);
    glVertex3fv(P042);
    glNormal3fv(N050);
    glVertex3fv(P050);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N041);
    glVertex3fv(P041);
    glNormal3fv(N050);
    glVertex3fv(P050);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glNormal3fv(N045);
    glVertex3fv(P045);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glNormal3fv(N041);
    glVertex3fv(P041);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glNormal3fv(N047);
    glVertex3fv(P047);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glNormal3fv(N045);
    glVertex3fv(P045);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glNormal3fv(N046);
    glVertex3fv(P046);
    glNormal3fv(N045);
    glVertex3fv(P045);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glNormal3fv(N047);
    glVertex3fv(P047);
    glNormal3fv(N046);
    glVertex3fv(P046);
    glEnd;
End;

Procedure Dolphin009;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N050);
    glVertex3fv(P050);
    glNormal3fv(N051);
    glVertex3fv(P051);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N051);
    glVertex3fv(P051);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glNormal3fv(N052);
    glVertex3fv(P052);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glNormal3fv(N045);
    glVertex3fv(P045);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glNormal3fv(N052);
    glVertex3fv(P052);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glNormal3fv(N050);
    glVertex3fv(P050);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glNormal3fv(N057);
    glVertex3fv(P057);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glNormal3fv(N057);
    glVertex3fv(P057);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glNormal3fv(N057);
    glVertex3fv(P057);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N047);
    glVertex3fv(P047);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N047);
    glVertex3fv(P047);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glNormal3fv(N055);
    glVertex3fv(P055);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N045);
    glVertex3fv(P045);
    glNormal3fv(N046);
    glVertex3fv(P046);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N046);
    glVertex3fv(P046);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N046);
    glVertex3fv(P046);
    glNormal3fv(N047);
    glVertex3fv(P047);
    glNormal3fv(N055);
    glVertex3fv(P055);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glEnd;
End;

Procedure Dolphin010;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N080);
    glVertex3fv(P080);
    glNormal3fv(N081);
    glVertex3fv(P081);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N081);
    glVertex3fv(P081);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N087);
    glVertex3fv(P087);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glNormal3fv(N087);
    glVertex3fv(P087);
    glNormal3fv(N090);
    glVertex3fv(P090);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N081);
    glVertex3fv(P081);
    glNormal3fv(N080);
    glVertex3fv(P080);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N081);
    glVertex3fv(P081);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N087);
    glVertex3fv(P087);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N087);
    glVertex3fv(P087);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glNormal3fv(N090);
    glVertex3fv(P090);
    glEnd;
End;

Procedure Dolphin011;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N082);
    glVertex3fv(P082);
    glNormal3fv(N084);
    glVertex3fv(P084);
    glNormal3fv(N079);
    glVertex3fv(P079);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N084);
    glVertex3fv(P084);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N079);
    glVertex3fv(P079);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N079);
    glVertex3fv(P079);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N088);
    glVertex3fv(P088);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glNormal3fv(N088);
    glVertex3fv(P088);
    glNormal3fv(N089);
    glVertex3fv(P089);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N088);
    glVertex3fv(P088);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N089);
    glVertex3fv(P089);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N089);
    glVertex3fv(P089);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N084);
    glVertex3fv(P084);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glNormal3fv(N084);
    glVertex3fv(P084);
    glNormal3fv(N079);
    glVertex3fv(P079);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N084);
    glVertex3fv(P084);
    glNormal3fv(N082);
    glVertex3fv(P082);
    glNormal3fv(N079);
    glVertex3fv(P079);
    glEnd;
End;

Procedure Dolphin012;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glNormal3fv(N067);
    glVertex3fv(P067);
    glNormal3fv(N066);
    glVertex3fv(P066);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glNormal3fv(N052);
    glVertex3fv(P052);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glNormal3fv(N067);
    glVertex3fv(P067);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glNormal3fv(N066);
    glVertex3fv(P066);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glNormal3fv(N057);
    glVertex3fv(P057);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glNormal3fv(N057);
    glVertex3fv(P057);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glNormal3fv(N055);
    glVertex3fv(P055);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glNormal3fv(N062);
    glVertex3fv(P062);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N052);
    glVertex3fv(P052);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glEnd;
End;

Procedure Dolphin013;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N116);
    glVertex3fv(P116);
    glNormal3fv(N117);
    glVertex3fv(P117);
    glNormal3fv(N112);
    glVertex3fv(P112);
    glNormal3fv(N113);
    glVertex3fv(P113);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N114);
    glVertex3fv(P114);
    glNormal3fv(N113);
    glVertex3fv(P113);
    glNormal3fv(N112);
    glVertex3fv(P112);
    glNormal3fv(N115);
    glVertex3fv(P115);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N114);
    glVertex3fv(P114);
    glNormal3fv(N116);
    glVertex3fv(P116);
    glNormal3fv(N113);
    glVertex3fv(P113);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N114);
    glVertex3fv(P114);
    glNormal3fv(N007);
    glVertex3fv(P007);
    glNormal3fv(N116);
    glVertex3fv(P116);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N007);
    glVertex3fv(P007);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glNormal3fv(N116);
    glVertex3fv(P116);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P002);
    glVertex3fv(P007);
    glVertex3fv(P008);
    glVertex3fv(P099);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P007);
    glVertex3fv(P114);
    glVertex3fv(P115);
    glVertex3fv(P008);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N117);
    glVertex3fv(P117);
    glNormal3fv(N099);
    glVertex3fv(P099);
    glNormal3fv(N008);
    glVertex3fv(P008);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N117);
    glVertex3fv(P117);
    glNormal3fv(N008);
    glVertex3fv(P008);
    glNormal3fv(N112);
    glVertex3fv(P112);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N112);
    glVertex3fv(P112);
    glNormal3fv(N008);
    glVertex3fv(P008);
    glNormal3fv(N115);
    glVertex3fv(P115);
    glEnd;
End;

Procedure Dolphin014;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N111);
    glVertex3fv(P111);
    glNormal3fv(N110);
    glVertex3fv(P110);
    glNormal3fv(N102);
    glVertex3fv(P102);
    glNormal3fv(N121);
    glVertex3fv(P121);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N111);
    glVertex3fv(P111);
    glNormal3fv(N097);
    glVertex3fv(P097);
    glNormal3fv(N110);
    glVertex3fv(P110);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N097);
    glVertex3fv(P097);
    glNormal3fv(N119);
    glVertex3fv(P119);
    glNormal3fv(N110);
    glVertex3fv(P110);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N097);
    glVertex3fv(P097);
    glNormal3fv(N099);
    glVertex3fv(P099);
    glNormal3fv(N119);
    glVertex3fv(P119);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N099);
    glVertex3fv(P099);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glNormal3fv(N119);
    glVertex3fv(P119);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glNormal3fv(N066);
    glVertex3fv(P066);
    glNormal3fv(N119);
    glVertex3fv(P119);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P098);
    glVertex3fv(P097);
    glVertex3fv(P111);
    glVertex3fv(P121);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P002);
    glVertex3fv(P099);
    glVertex3fv(P097);
    glVertex3fv(P098);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N110);
    glVertex3fv(P110);
    glNormal3fv(N119);
    glVertex3fv(P119);
    glNormal3fv(N118);
    glVertex3fv(P118);
    glNormal3fv(N102);
    glVertex3fv(P102);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N119);
    glVertex3fv(P119);
    glNormal3fv(N066);
    glVertex3fv(P066);
    glNormal3fv(N067);
    glVertex3fv(P067);
    glNormal3fv(N118);
    glVertex3fv(P118);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N067);
    glVertex3fv(P067);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N067);
    glVertex3fv(P067);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glNormal3fv(N118);
    glVertex3fv(P118);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N118);
    glVertex3fv(P118);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glNormal3fv(N098);
    glVertex3fv(P098);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N118);
    glVertex3fv(P118);
    glNormal3fv(N098);
    glVertex3fv(P098);
    glNormal3fv(N102);
    glVertex3fv(P102);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N102);
    glVertex3fv(P102);
    glNormal3fv(N098);
    glVertex3fv(P098);
    glNormal3fv(N121);
    glVertex3fv(P121);
    glEnd;
End;

Procedure Dolphin015;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N055);
    glVertex3fv(P055);
    glNormal3fv(N003);
    glVertex3fv(P003);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N003);
    glVertex3fv(P003);
    glNormal3fv(N055);
    glVertex3fv(P055);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N003);
    glVertex3fv(P003);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N003);
    glVertex3fv(P003);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glNormal3fv(N062);
    glVertex3fv(P062);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glNormal3fv(N064);
    glVertex3fv(P064);
    glNormal3fv(N120);
    glVertex3fv(P120);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glNormal3fv(N064);
    glVertex3fv(P064);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glNormal3fv(N064);
    glVertex3fv(P064);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N064);
    glVertex3fv(P064);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glNormal3fv(N099);
    glVertex3fv(P099);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N064);
    glVertex3fv(P064);
    glNormal3fv(N099);
    glVertex3fv(P099);
    glNormal3fv(N117);
    glVertex3fv(P117);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N120);
    glVertex3fv(P120);
    glNormal3fv(N064);
    glVertex3fv(P064);
    glNormal3fv(N117);
    glVertex3fv(P117);
    glNormal3fv(N116);
    glVertex3fv(P116);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glNormal3fv(N099);
    glVertex3fv(P099);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N062);
    glVertex3fv(P062);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glNormal3fv(N120);
    glVertex3fv(P120);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glNormal3fv(N062);
    glVertex3fv(P062);
    glNormal3fv(N120);
    glVertex3fv(P120);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glNormal3fv(N120);
    glVertex3fv(P120);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glNormal3fv(N120);
    glVertex3fv(P120);
    glNormal3fv(N116);
    glVertex3fv(P116);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glEnd;
End;

Procedure Dolphin016;
Begin
    glDisable(GL_DEPTH_TEST);
    glBegin(GL_POLYGON);
    glVertex3fv(P123);
    glVertex3fv(P124);
    glVertex3fv(P125);
    glVertex3fv(P126);
    glVertex3fv(P127);
    glVertex3fv(P128);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P129);
    glVertex3fv(P130);
    glVertex3fv(P131);
    glVertex3fv(P132);
    glVertex3fv(P133);
    glVertex3fv(P134);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P103);
    glVertex3fv(P105);
    glVertex3fv(P108);
    glEnd;
    glEnable(GL_DEPTH_TEST);
End;

Procedure DrawDolphin(Var fish:fishRec);
Var
   seg0, seg1, seg2, seg3, seg4, seg5, seg6, seg7:Single;
   pitch, thrash, chomp:Single;
Begin
    fish.htail := Round(fish.htail - Round(10.0 * fish.v)) Mod 360;

    thrash := 70.0 * fish.v;

    seg0 := 1.0 * thrash * sin((fish.htail) * RRAD);
    seg3 := 1.0 * thrash * sin((fish.htail) * RRAD);
    seg1 := 2.0 * thrash * sin((fish.htail + 4.0) * RRAD);
    seg2 := 3.0 * thrash * sin((fish.htail + 6.0) * RRAD);
    seg4 := 4.0 * thrash * sin((fish.htail + 10.0) * RRAD);
    seg5 := 4.5 * thrash * sin((fish.htail + 15.0) * RRAD);
    seg6 := 5.0 * thrash * sin((fish.htail + 20.0) * RRAD);
    seg7 := 6.0 * thrash * sin((fish.htail + 30.0) * RRAD);

    pitch := fish.v * sin((fish.htail + 180.0) * RRAD);

    If fish.v > 2.0 Then chomp := -(fish.v - 2.0) * 200.0
    Else chomp := 100.0;

    P012[1] := iP012[1] + seg5;
    P013[1] := iP013[1] + seg5;
    P014[1] := iP014[1] + seg5;
    P015[1] := iP015[1] + seg5;
    P016[1] := iP016[1] + seg5;
    P017[1] := iP017[1] + seg5;
    P018[1] := iP018[1] + seg5;
    P019[1] := iP019[1] + seg5;

    P020[1] := iP020[1] + seg4;
    P021[1] := iP021[1] + seg4;
    P022[1] := iP022[1] + seg4;
    P023[1] := iP023[1] + seg4;
    P024[1] := iP024[1] + seg4;
    P025[1] := iP025[1] + seg4;
    P026[1] := iP026[1] + seg4;
    P027[1] := iP027[1] + seg4;

    P028[1] := iP028[1] + seg2;
    P029[1] := iP029[1] + seg2;
    P030[1] := iP030[1] + seg2;
    P031[1] := iP031[1] + seg2;
    P032[1] := iP032[1] + seg2;
    P033[1] := iP033[1] + seg2;
    P034[1] := iP034[1] + seg2;
    P035[1] := iP035[1] + seg2;

    P036[1] := iP036[1] + seg1;
    P037[1] := iP037[1] + seg1;
    P038[1] := iP038[1] + seg1;
    P039[1] := iP039[1] + seg1;
    P040[1] := iP040[1] + seg1;
    P041[1] := iP041[1] + seg1;
    P042[1] := iP042[1] + seg1;
    P043[1] := iP043[1] + seg1;

    P044[1] := iP044[1] + seg0;
    P045[1] := iP045[1] + seg0;
    P046[1] := iP046[1] + seg0;
    P047[1] := iP047[1] + seg0;
    P048[1] := iP048[1] + seg0;
    P049[1] := iP049[1] + seg0;
    P050[1] := iP050[1] + seg0;
    P051[1] := iP051[1] + seg0;

    P009[1] := iP009[1] + seg6;
    P010[1] := iP010[1] + seg6;
    P075[1] := iP075[1] + seg6;
    P076[1] := iP076[1] + seg6;

    P001[1] := iP001[1] + seg7;
    P011[1] := iP011[1] + seg7;
    P068[1] := iP068[1] + seg7;
    P069[1] := iP069[1] + seg7;
    P070[1] := iP070[1] + seg7;
    P071[1] := iP071[1] + seg7;
    P072[1] := iP072[1] + seg7;
    P073[1] := iP073[1] + seg7;
    P074[1] := iP074[1] + seg7;

    P091[1] := iP091[1] + seg3;
    P092[1] := iP092[1] + seg3;
    P093[1] := iP093[1] + seg3;
    P094[1] := iP094[1] + seg3;
    P095[1] := iP095[1] + seg3;
    P122[1] := iP122[1] + seg3 * 1.5;

    P097[1] := iP097[1] + chomp;
    P098[1] := iP098[1] + chomp;
    P102[1] := iP102[1] + chomp;
    P110[1] := iP110[1] + chomp;
    P111[1] := iP111[1] + chomp;
    P121[1] := iP121[1] + chomp;
    P118[1] := iP118[1] + chomp;
    P119[1] := iP119[1] + chomp;

    glPushMatrix;

    glRotatef(pitch, 1.0, 0.0, 0.0);

    glTranslatef(0.0, 0.0, 7000.0);

    glRotatef(180.0, 0.0, 1.0, 0.0);

    glEnable(GL_CULL_FACE);
    Dolphin014;
    Dolphin010;
    Dolphin009;
    Dolphin012;
    Dolphin013;
    Dolphin006;
    Dolphin002;
    Dolphin001;
    Dolphin003;
    Dolphin015;
    Dolphin004;
    Dolphin005;
    Dolphin007;
    Dolphin008;
    Dolphin011;
    Dolphin016;
    glDisable(GL_CULL_FACE);

    glPopMatrix;
End;

End.