Unit Whale;

{**
 * (c) Copyright 1993, 1994, Silicon Graphics, Inc.
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Silicon Graphics, Inc. not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL SILICON
 * GRAPHICS, INC.  BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT SILICON GRAPHICS, INC.  HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * US Government Users Restricted Rights
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in FAR 52.227.19(c)(2) or subparagraph
 * (c)(1)(ii) of the Rights in Technical Data and Computer Software
 * clause at DFARS 252.227-7013 and/or in similar or successor
 * clauses in the FAR or the DOD or NASA FAR Supplement.
 * Unpublished-- rights reserved under the copyright laws of the
 * United States.  Contractor/manufacturer is Silicon Graphics,
 * Inc., 2011 N.  Shoreline Blvd., Mountain View, CA 94039-7311.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 *
}

Interface

Uses ATBase,OpenGL;

Procedure DrawWhale(Var fish:fishRec);

Implementation

Const
      N001:Array[0..2] Of Single = (0.019249 ,0.011340 ,-0.999750);
      N002:Array[0..2] Of Single = (-0.132579 ,0.954547 ,0.266952);
      N003:Array[0..2] Of Single = (-0.196061 ,0.980392 ,-0.019778);
      N004:Array[0..2] Of Single = (0.695461 ,0.604704 ,0.388158);
      N005:Array[0..2] Of Single = (0.870600 ,0.425754 ,0.246557);
      N006:Array[0..2] Of Single = (-0.881191 ,0.392012 ,0.264251);
      N007:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N008:Array[0..2] Of Single = (-0.341437 ,0.887477 ,0.309523);
      N009:Array[0..2] Of Single = (0.124035 ,-0.992278 ,0.000000);
      N010:Array[0..2] Of Single = (0.242536 ,0.000000 ,-0.970143);
      N011:Array[0..2] Of Single = (0.588172 ,0.000000 ,0.808736);
      N012:Array[0..2] Of Single = (0.929824 ,-0.340623 ,-0.139298);
      N013:Array[0..2] Of Single = (0.954183 ,0.267108 ,-0.134865);
      N014:Array[0..2] Of Single = (0.495127 ,0.855436 ,-0.151914);
      N015:Array[0..2] Of Single = (-0.390199 ,0.906569 ,-0.160867);
      N016:Array[0..2] Of Single = (-0.923605 ,0.354581 ,-0.145692);
      N017:Array[0..2] Of Single = (-0.955796 ,-0.260667 ,-0.136036);
      N018:Array[0..2] Of Single = (-0.501283 ,-0.853462 ,-0.142540);
      N019:Array[0..2] Of Single = (0.405300 ,-0.901974 ,-0.148913);
      N020:Array[0..2] Of Single = (0.909913 ,-0.392746 ,-0.133451);
      N021:Array[0..2] Of Single = (0.936494 ,0.331147 ,-0.115414);
      N022:Array[0..2] Of Single = (0.600131 ,0.793724 ,-0.099222);
      N023:Array[0..2] Of Single = (-0.231556 ,0.968361 ,-0.093053);
      N024:Array[0..2] Of Single = (-0.844369 ,0.525330 ,-0.105211);
      N025:Array[0..2] Of Single = (-0.982725 ,-0.136329 ,-0.125164);
      N026:Array[0..2] Of Single = (-0.560844 ,-0.822654 ,-0.093241);
      N027:Array[0..2] Of Single = (0.263884 ,-0.959981 ,-0.093817);
      N028:Array[0..2] Of Single = (0.842057 ,-0.525192 ,-0.122938);
      N029:Array[0..2] Of Single = (0.921620 ,0.367565 ,-0.124546);
      N030:Array[0..2] Of Single = (0.613927 ,0.784109 ,-0.090918);
      N031:Array[0..2] Of Single = (-0.448754 ,0.888261 ,-0.098037);
      N032:Array[0..2] Of Single = (-0.891865 ,0.434376 ,-0.126077);
      N033:Array[0..2] Of Single = (-0.881447 ,-0.448017 ,-0.149437);
      N034:Array[0..2] Of Single = (-0.345647 ,-0.922057 ,-0.174183);
      N035:Array[0..2] Of Single = (0.307998 ,-0.941371 ,-0.137688);
      N036:Array[0..2] Of Single = (0.806316 ,-0.574647 ,-0.140124);
      N037:Array[0..2] Of Single = (0.961346 ,0.233646 ,-0.145681);
      N038:Array[0..2] Of Single = (0.488451 ,0.865586 ,-0.110351);
      N039:Array[0..2] Of Single = (-0.374290 ,0.921953 ,-0.099553);
      N040:Array[0..2] Of Single = (-0.928504 ,0.344533 ,-0.138485);
      N041:Array[0..2] Of Single = (-0.918419 ,-0.371792 ,-0.135189);
      N042:Array[0..2] Of Single = (-0.520666 ,-0.833704 ,-0.183968);
      N043:Array[0..2] Of Single = (0.339204 ,-0.920273 ,-0.195036);
      N044:Array[0..2] Of Single = (0.921475 ,-0.387382 ,-0.028636);
      N045:Array[0..2] Of Single = (0.842465 ,0.533335 ,-0.076204);
      N046:Array[0..2] Of Single = (0.380110 ,0.924939 ,0.002073);
      N047:Array[0..2] Of Single = (-0.276128 ,0.961073 ,-0.009579);
      N048:Array[0..2] Of Single = (-0.879684 ,0.473001 ,-0.049250);
      N049:Array[0..2] Of Single = (-0.947184 ,-0.317614 ,-0.044321);
      N050:Array[0..2] Of Single = (-0.642059 ,-0.764933 ,-0.051363);
      N051:Array[0..2] Of Single = (0.466794 ,-0.880921 ,-0.077990);
      N052:Array[0..2] Of Single = (0.898509 ,-0.432277 ,0.076279);
      N053:Array[0..2] Of Single = (0.938985 ,0.328141 ,0.103109);
      N054:Array[0..2] Of Single = (0.442420 ,0.895745 ,0.043647);
      N055:Array[0..2] Of Single = (-0.255163 ,0.966723 ,0.018407);
      N056:Array[0..2] Of Single = (-0.833769 ,0.540650 ,0.111924);
      N057:Array[0..2] Of Single = (-0.953653 ,-0.289939 ,0.080507);
      N058:Array[0..2] Of Single = (-0.672357 ,-0.730524 ,0.119461);
      N059:Array[0..2] Of Single = (0.522249 ,-0.846652 ,0.102157);
      N060:Array[0..2] Of Single = (0.885868 ,-0.427631 ,0.179914);
      N061:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N062:Array[0..2] Of Single = (0.648942 ,0.743116 ,0.163255);
      N063:Array[0..2] Of Single = (-0.578967 ,0.807730 ,0.111219);
      N064:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N065:Array[0..2] Of Single = (-0.909864 ,-0.352202 ,0.219321);
      N066:Array[0..2] Of Single = (-0.502541 ,-0.818090 ,0.279610);
      N067:Array[0..2] Of Single = (0.322919 ,-0.915358 ,0.240504);
      N068:Array[0..2] Of Single = (0.242536 ,0.000000 ,-0.970143);
      N069:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N070:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N071:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N072:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N073:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N074:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N075:Array[0..2] Of Single = (0.031220 ,0.999025 ,-0.031220);
      N076:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N077:Array[0..2] Of Single = (0.446821 ,0.893642 ,0.041889);
      N078:Array[0..2] Of Single = (0.863035 ,-0.100980 ,0.494949);
      N079:Array[0..2] Of Single = (0.585597 ,-0.808215 ,0.062174);
      N080:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N081:Array[0..2] Of Single = (1.000000 ,0.000000 ,0.000000);
      N082:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N083:Array[0..2] Of Single = (-1.000000 ,0.000000 ,0.000000);
      N084:Array[0..2] Of Single = (-0.478893 ,0.837129 ,-0.264343);
      N085:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N086:Array[0..2] Of Single = (0.763909 ,0.539455 ,-0.354163);
      N087:Array[0..2] Of Single = (0.446821 ,0.893642 ,0.041889);
      N088:Array[0..2] Of Single = (0.385134 ,-0.908288 ,0.163352);
      N089:Array[0..2] Of Single = (-0.605952 ,0.779253 ,-0.159961);
      N090:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N091:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N092:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N093:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N094:Array[0..2] Of Single = (1.000000 ,0.000000 ,0.000000);
      N095:Array[0..2] Of Single = (-1.000000 ,0.000000 ,0.000000);
      N096:Array[0..2] Of Single = (0.644444 ,-0.621516 ,0.445433);
      N097:Array[0..2] Of Single = (-0.760896 ,-0.474416 ,0.442681);
      N098:Array[0..2] Of Single = (0.636888 ,-0.464314 ,0.615456);
      N099:Array[0..2] Of Single = (-0.710295 ,0.647038 ,0.277168);
      N100:Array[0..2] Of Single = (0.009604 ,0.993655 ,0.112063);
      N101:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N102:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N103:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N104:Array[0..2] Of Single = (0.031837 ,0.999285 ,0.020415);
      N105:Array[0..2] Of Single = (0.031837 ,0.999285 ,0.020415);
      N106:Array[0..2] Of Single = (0.031837 ,0.999285 ,0.020415);
      N107:Array[0..2] Of Single = (0.014647 ,0.999648 ,0.022115);
      N108:Array[0..2] Of Single = (0.014647 ,0.999648 ,0.022115);
      N109:Array[0..2] Of Single = (0.014647 ,0.999648 ,0.022115);
      N110:Array[0..2] Of Single = (-0.985141 ,0.039475 ,0.167149);
      N111:Array[0..2] Of Single = (-0.985141 ,0.039475 ,0.167149);
      N112:Array[0..2] Of Single = (-0.985141 ,0.039475 ,0.167149);
      N113:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N114:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N115:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N116:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N117:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N118:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N119:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N120:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      N121:Array[0..2] Of Single = (0.000000 ,1.000000 ,0.000000);
      iP001:Array[0..2] Of Single = (18.74, 13.19, 3.76);
      P001:Array[0..2] Of Single = (18.74, 13.19, 3.76);
      P002:Array[0..2] Of Single = (0.00, 390.42, 10292.57);
      P003:Array[0..2] Of Single = (55.80, 622.31, 8254.35);
      P004:Array[0..2] Of Single = (20.80, 247.66, 10652.13);
      P005:Array[0..2] Of Single = (487.51, 198.05, 9350.78);
      P006:Array[0..2] Of Single = (-457.61, 199.04, 9353.01);
      P007:Array[0..2] Of Single = (0.00, 259.00, 10276.27);
      P008:Array[0..2] Of Single = (-34.67, 247.64, 10663.71);
      iP009:Array[0..2] Of Single = (97.46, 67.63, 593.82);
      iP010:Array[0..2] Of Single = (-84.33, 67.63, 588.18);
      iP011:Array[0..2] Of Single = (118.69, 8.98, -66.91);
      P009:Array[0..2] Of Single = (97.46, 67.63, 593.82);
      P010:Array[0..2] Of Single = (-84.33, 67.63, 588.18);
      P011:Array[0..2] Of Single = (118.69, 8.98, -66.91);
      iP012:Array[0..2] Of Single = (156.48, -31.95, 924.54);
      iP013:Array[0..2] Of Single = (162.00, 110.22, 924.54);
      iP014:Array[0..2] Of Single = (88.16, 221.65, 924.54);
      iP015:Array[0..2] Of Single = (-65.21, 231.16, 924.54);
      iP016:Array[0..2] Of Single = (-156.48, 121.97, 924.54);
      iP017:Array[0..2] Of Single = (-162.00, -23.93, 924.54);
      iP018:Array[0..2] Of Single = (-88.16, -139.10, 924.54);
      iP019:Array[0..2] Of Single = (65.21, -148.61, 924.54);
      iP020:Array[0..2] Of Single = (246.87, -98.73, 1783.04);
      iP021:Array[0..2] Of Single = (253.17, 127.76, 1783.04);
      iP022:Array[0..2] Of Single = (132.34, 270.77, 1783.04);
      iP023:Array[0..2] Of Single = (-97.88, 285.04, 1783.04);
      iP024:Array[0..2] Of Single = (-222.97, 139.80, 1783.04);
      iP025:Array[0..2] Of Single = (-225.29, -86.68, 1783.04);
      iP026:Array[0..2] Of Single = (-108.44, -224.15, 1783.04);
      iP027:Array[0..2] Of Single = (97.88, -221.56, 1783.04);
      iP028:Array[0..2] Of Single = (410.55, -200.66, 3213.87);
      iP029:Array[0..2] Of Single = (432.19, 148.42, 3213.87);
      iP030:Array[0..2] Of Single = (200.66, 410.55, 3213.87);
      iP031:Array[0..2] Of Single = (-148.42, 432.19, 3213.87);
      iP032:Array[0..2] Of Single = (-407.48, 171.88, 3213.87);
      iP033:Array[0..2] Of Single = (-432.19, -148.42, 3213.87);
      iP034:Array[0..2] Of Single = (-148.88, -309.74, 3213.87);
      iP035:Array[0..2] Of Single = (156.38, -320.17, 3213.87);
      iP036:Array[0..2] Of Single = (523.39, -303.81, 4424.57);
      iP037:Array[0..2] Of Single = (574.66, 276.84, 4424.57);
      iP038:Array[0..2] Of Single = (243.05, 492.50, 4424.57);
      iP039:Array[0..2] Of Single = (-191.23, 520.13, 4424.57);
      iP040:Array[0..2] Of Single = (-523.39, 304.01, 4424.57);
      iP041:Array[0..2] Of Single = (-574.66, -231.83, 4424.57);
      iP042:Array[0..2] Of Single = (-266.95, -578.17, 4424.57);
      iP043:Array[0..2] Of Single = (211.14, -579.67, 4424.57);
      iP044:Array[0..2] Of Single = (680.57, -370.27, 5943.46);
      iP045:Array[0..2] Of Single = (834.01, 363.09, 5943.46);
      iP046:Array[0..2] Of Single = (371.29, 614.13, 5943.46);
      iP047:Array[0..2] Of Single = (-291.43, 621.86, 5943.46);
      iP048:Array[0..2] Of Single = (-784.13, 362.60, 5943.46);
      iP049:Array[0..2] Of Single = (-743.29, -325.82, 5943.46);
      iP050:Array[0..2] Of Single = (-383.24, -804.77, 5943.46);
      iP051:Array[0..2] Of Single = (283.47, -846.09, 5943.46);
      P012:Array[0..2] Of Single = (156.48, -31.95, 924.54);
      P013:Array[0..2] Of Single = (162.00, 110.22, 924.54);
      P014:Array[0..2] Of Single = (88.16, 221.65, 924.54);
      P015:Array[0..2] Of Single = (-65.21, 231.16, 924.54);
      P016:Array[0..2] Of Single = (-156.48, 121.97, 924.54);
      P017:Array[0..2] Of Single = (-162.00, -23.93, 924.54);
      P018:Array[0..2] Of Single = (-88.16, -139.10, 924.54);
      P019:Array[0..2] Of Single = (65.21, -148.61, 924.54);
      P020:Array[0..2] Of Single = (246.87, -98.73, 1783.04);
      P021:Array[0..2] Of Single = (253.17, 127.76, 1783.04);
      P022:Array[0..2] Of Single = (132.34, 270.77, 1783.04);
      P023:Array[0..2] Of Single = (-97.88, 285.04, 1783.04);
      P024:Array[0..2] Of Single = (-222.97, 139.80, 1783.04);
      P025:Array[0..2] Of Single = (-225.29, -86.68, 1783.04);
      P026:Array[0..2] Of Single = (-108.44, -224.15, 1783.04);
      P027:Array[0..2] Of Single = (97.88, -221.56, 1783.04);
      P028:Array[0..2] Of Single = (410.55, -200.66, 3213.87);
      P029:Array[0..2] Of Single = (432.19, 148.42, 3213.87);
      P030:Array[0..2] Of Single = (200.66, 410.55, 3213.87);
      P031:Array[0..2] Of Single = (-148.42, 432.19, 3213.87);
      P032:Array[0..2] Of Single = (-407.48, 171.88, 3213.87);
      P033:Array[0..2] Of Single = (-432.19, -148.42, 3213.87);
      P034:Array[0..2] Of Single = (-148.88, -309.74, 3213.87);
      P035:Array[0..2] Of Single = (156.38, -320.17, 3213.87);
      P036:Array[0..2] Of Single = (523.39, -303.81, 4424.57);
      P037:Array[0..2] Of Single = (574.66, 276.84, 4424.57);
      P038:Array[0..2] Of Single = (243.05, 492.50, 4424.57);
      P039:Array[0..2] Of Single = (-191.23, 520.13, 4424.57);
      P040:Array[0..2] Of Single = (-523.39, 304.01, 4424.57);
      P041:Array[0..2] Of Single = (-574.66, -231.83, 4424.57);
      P042:Array[0..2] Of Single = (-266.95, -578.17, 4424.57);
      P043:Array[0..2] Of Single = (211.14, -579.67, 4424.57);
      P044:Array[0..2] Of Single = (680.57, -370.27, 5943.46);
      P045:Array[0..2] Of Single = (834.01, 363.09, 5943.46);
      P046:Array[0..2] Of Single = (371.29, 614.13, 5943.46);
      P047:Array[0..2] Of Single = (-291.43, 621.86, 5943.46);
      P048:Array[0..2] Of Single = (-784.13, 362.60, 5943.46);
      P049:Array[0..2] Of Single = (-743.29, -325.82, 5943.46);
      P050:Array[0..2] Of Single = (-383.24, -804.77, 5943.46);
      P051:Array[0..2] Of Single = (283.47, -846.09, 5943.46);
      P052:Array[0..2] Of Single = (599.09, -332.24, 7902.59);
      P053:Array[0..2] Of Single = (735.48, 306.26, 7911.92);
      P054:Array[0..2] Of Single = (321.55, 558.53, 7902.59);
      P055:Array[0..2] Of Single = (-260.54, 559.84, 7902.59);
      P056:Array[0..2] Of Single = (-698.66, 320.83, 7902.59);
      P057:Array[0..2] Of Single = (-643.29, -299.16, 7902.59);
      P058:Array[0..2] Of Single = (-341.47, -719.30, 7902.59);
      P059:Array[0..2] Of Single = (252.57, -756.12, 7902.59);
      P060:Array[0..2] Of Single = (458.39, -265.31, 9355.44);
      iP061:Array[0..2] Of Single = (353.63, 138.70, 10214.20);
      P061:Array[0..2] Of Single = (353.63, 138.70, 10214.20);
      P062:Array[0..2] Of Single = (224.04, 438.98, 9364.77);
      P063:Array[0..2] Of Single = (-165.71, 441.27, 9355.44);
      iP064:Array[0..2] Of Single = (-326.40, 162.04, 10209.54);
      P064:Array[0..2] Of Single = (-326.40, 162.04, 10209.54);
      P065:Array[0..2] Of Single = (-473.99, -219.71, 9355.44);
      P066:Array[0..2] Of Single = (-211.97, -479.87, 9355.44);
      P067:Array[0..2] Of Single = (192.86, -504.03, 9355.44);
      iP068:Array[0..2] Of Single = (-112.44, 9.25, -64.42);
      iP069:Array[0..2] Of Single = (1155.63, 0.00, -182.46);
      iP070:Array[0..2] Of Single = (-1143.13, 0.00, -181.54);
      iP071:Array[0..2] Of Single = (1424.23, 0.00, -322.09);
      iP072:Array[0..2] Of Single = (-1368.01, 0.00, -310.38);
      iP073:Array[0..2] Of Single = (1255.57, 2.31, 114.05);
      iP074:Array[0..2] Of Single = (-1149.38, 0.00, 117.12);
      iP075:Array[0..2] Of Single = (718.36, 0.00, 433.36);
      iP076:Array[0..2] Of Single = (-655.90, 0.00, 433.36);
      P068:Array[0..2] Of Single = (-112.44, 9.25, -64.42);
      P069:Array[0..2] Of Single = (1155.63, 0.00, -182.46);
      P070:Array[0..2] Of Single = (-1143.13, 0.00, -181.54);
      P071:Array[0..2] Of Single = (1424.23, 0.00, -322.09);
      P072:Array[0..2] Of Single = (-1368.01, 0.00, -310.38);
      P073:Array[0..2] Of Single = (1255.57, 2.31, 114.05);
      P074:Array[0..2] Of Single = (-1149.38, 0.00, 117.12);
      P075:Array[0..2] Of Single = (718.36, 0.00, 433.36);
      P076:Array[0..2] Of Single = (-655.90, 0.00, 433.36);
      P077:Array[0..2] Of Single = (1058.00, -2.66, 7923.51);
      P078:Array[0..2] Of Single = (-1016.51, -15.47, 7902.87);
      P079:Array[0..2] Of Single = (-1363.99, -484.50, 7593.38);
      P080:Array[0..2] Of Single = (1478.09, -861.47, 7098.12);
      P081:Array[0..2] Of Single = (1338.06, -284.68, 7024.15);
      P082:Array[0..2] Of Single = (-1545.51, -860.64, 7106.60);
      P083:Array[0..2] Of Single = (1063.19, -70.46, 7466.60);
      P084:Array[0..2] Of Single = (-1369.18, -288.11, 7015.34);
      P085:Array[0..2] Of Single = (1348.44, -482.50, 7591.41);
      P086:Array[0..2] Of Single = (-1015.45, -96.80, 7474.86);
      P087:Array[0..2] Of Single = (731.04, 148.38, 7682.58);
      P088:Array[0..2] Of Single = (-697.03, 151.82, 7668.81);
      P089:Array[0..2] Of Single = (-686.82, 157.09, 7922.29);
      P090:Array[0..2] Of Single = (724.73, 147.75, 7931.39);
      iP091:Array[0..2] Of Single = (0.00, 327.10, 2346.55);
      iP092:Array[0..2] Of Single = (0.00, 552.28, 2311.31);
      iP093:Array[0..2] Of Single = (0.00, 721.16, 2166.41);
      iP094:Array[0..2] Of Single = (0.00, 693.42, 2388.80);
      iP095:Array[0..2] Of Single = (0.00, 389.44, 2859.97);
      P091:Array[0..2] Of Single = (0.00, 327.10, 2346.55);
      P092:Array[0..2] Of Single = (0.00, 552.28, 2311.31);
      P093:Array[0..2] Of Single = (0.00, 721.16, 2166.41);
      P094:Array[0..2] Of Single = (0.00, 693.42, 2388.80);
      P095:Array[0..2] Of Single = (0.00, 389.44, 2859.97);
      iP096:Array[0..2] Of Single = (222.02, -183.67, 10266.89);
      iP097:Array[0..2] Of Single = (-128.90, -182.70, 10266.89);
      iP098:Array[0..2] Of Single = (41.04, 88.31, 10659.36);
      iP099:Array[0..2] Of Single = (-48.73, 88.30, 10659.36);
      P096:Array[0..2] Of Single = (222.02, -183.67, 10266.89);
      P097:Array[0..2] Of Single = (-128.90, -182.70, 10266.89);
      P098:Array[0..2] Of Single = (41.04, 88.31, 10659.36);
      P099:Array[0..2] Of Single = (-48.73, 88.30, 10659.36);
      P100:Array[0..2] Of Single = (0.00, 603.42, 9340.68);
      P101:Array[0..2] Of Single = (5.70, 567.00, 7862.98);
      P102:Array[0..2] Of Single = (521.61, 156.61, 9162.34);
      P103:Array[0..2] Of Single = (83.68, 566.67, 7861.26);
      P104:Array[0..2] Of Single = (-9.86, 567.62, 7858.65);
      P105:Array[0..2] Of Single = (31.96, 565.27, 7908.46);
      P106:Array[0..2] Of Single = (22.75, 568.13, 7782.83);
      P107:Array[0..2] Of Single = (58.93, 568.42, 7775.94);
      P108:Array[0..2] Of Single = (55.91, 565.59, 7905.86);
      P109:Array[0..2] Of Single = (99.21, 566.00, 7858.65);
      P110:Array[0..2] Of Single = (-498.83, 148.14, 9135.10);
      P111:Array[0..2] Of Single = (-495.46, 133.24, 9158.48);
      P112:Array[0..2] Of Single = (-490.82, 146.23, 9182.76);
      P113:Array[0..2] Of Single = (-489.55, 174.11, 9183.66);
      P114:Array[0..2] Of Single = (-492.92, 189.00, 9160.28);
      P115:Array[0..2] Of Single = (-497.56, 176.02, 9136.00);
      P116:Array[0..2] Of Single = (526.54, 169.68, 9137.70);
      P117:Array[0..2] Of Single = (523.49, 184.85, 9161.42);
      P118:Array[0..2] Of Single = (518.56, 171.78, 9186.06);
      P119:Array[0..2] Of Single = (516.68, 143.53, 9186.98);
      P120:Array[0..2] Of Single = (519.73, 128.36, 9163.26);
      P121:Array[0..2] Of Single = (524.66, 141.43, 9138.62);

Procedure Whale001;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N068);
    glVertex3fv(P068);
    glNormal3fv(N010);
    glVertex3fv(P010);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N068);
    glVertex3fv(P068);
    glNormal3fv(N076);
    glVertex3fv(P076);
    glNormal3fv(N010);
    glVertex3fv(P010);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N068);
    glVertex3fv(P068);
    glNormal3fv(N070);
    glVertex3fv(P070);
    glNormal3fv(N076);
    glVertex3fv(P076);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N076);
    glVertex3fv(P076);
    glNormal3fv(N070);
    glVertex3fv(P070);
    glNormal3fv(N074);
    glVertex3fv(P074);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N070);
    glVertex3fv(P070);
    glNormal3fv(N072);
    glVertex3fv(P072);
    glNormal3fv(N074);
    glVertex3fv(P074);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N072);
    glVertex3fv(P072);
    glNormal3fv(N070);
    glVertex3fv(P070);
    glNormal3fv(N074);
    glVertex3fv(P074);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N074);
    glVertex3fv(P074);
    glNormal3fv(N070);
    glVertex3fv(P070);
    glNormal3fv(N076);
    glVertex3fv(P076);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N070);
    glVertex3fv(P070);
    glNormal3fv(N068);
    glVertex3fv(P068);
    glNormal3fv(N076);
    glVertex3fv(P076);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N076);
    glVertex3fv(P076);
    glNormal3fv(N068);
    glVertex3fv(P068);
    glNormal3fv(N010);
    glVertex3fv(P010);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N068);
    glVertex3fv(P068);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N010);
    glVertex3fv(P010);
    glEnd;
End;

Procedure Whale002;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N011);
    glVertex3fv(P011);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N009);
    glVertex3fv(P009);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N075);
    glVertex3fv(P075);
    glNormal3fv(N011);
    glVertex3fv(P011);
    glNormal3fv(N009);
    glVertex3fv(P009);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N069);
    glVertex3fv(P069);
    glNormal3fv(N011);
    glVertex3fv(P011);
    glNormal3fv(N075);
    glVertex3fv(P075);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N069);
    glVertex3fv(P069);
    glNormal3fv(N075);
    glVertex3fv(P075);
    glNormal3fv(N073);
    glVertex3fv(P073);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N071);
    glVertex3fv(P071);
    glNormal3fv(N069);
    glVertex3fv(P069);
    glNormal3fv(N073);
    glVertex3fv(P073);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N011);
    glVertex3fv(P011);
    glNormal3fv(N009);
    glVertex3fv(P009);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N009);
    glVertex3fv(P009);
    glNormal3fv(N011);
    glVertex3fv(P011);
    glNormal3fv(N075);
    glVertex3fv(P075);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N011);
    glVertex3fv(P011);
    glNormal3fv(N069);
    glVertex3fv(P069);
    glNormal3fv(N075);
    glVertex3fv(P075);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N069);
    glVertex3fv(P069);
    glNormal3fv(N073);
    glVertex3fv(P073);
    glNormal3fv(N075);
    glVertex3fv(P075);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N069);
    glVertex3fv(P069);
    glNormal3fv(N071);
    glVertex3fv(P071);
    glNormal3fv(N073);
    glVertex3fv(P073);
    glEnd;
End;

Procedure Whale003;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N018);
    glVertex3fv(P018);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N019);
    glVertex3fv(P019);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N019);
    glVertex3fv(P019);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N012);
    glVertex3fv(P012);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N017);
    glVertex3fv(P017);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N018);
    glVertex3fv(P018);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N017);
    glVertex3fv(P017);
    glNormal3fv(N016);
    glVertex3fv(P016);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N013);
    glVertex3fv(P013);
    glNormal3fv(N012);
    glVertex3fv(P012);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N016);
    glVertex3fv(P016);
    glNormal3fv(N015);
    glVertex3fv(P015);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N014);
    glVertex3fv(P014);
    glNormal3fv(N013);
    glVertex3fv(P013);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N001);
    glVertex3fv(P001);
    glNormal3fv(N015);
    glVertex3fv(P015);
    glNormal3fv(N014);
    glVertex3fv(P014);
    glEnd;
End;

Procedure Whale004;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N014);
    glVertex3fv(P014);
    glNormal3fv(N015);
    glVertex3fv(P015);
    glNormal3fv(N023);
    glVertex3fv(P023);
    glNormal3fv(N022);
    glVertex3fv(P022);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N015);
    glVertex3fv(P015);
    glNormal3fv(N016);
    glVertex3fv(P016);
    glNormal3fv(N024);
    glVertex3fv(P024);
    glNormal3fv(N023);
    glVertex3fv(P023);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N016);
    glVertex3fv(P016);
    glNormal3fv(N017);
    glVertex3fv(P017);
    glNormal3fv(N025);
    glVertex3fv(P025);
    glNormal3fv(N024);
    glVertex3fv(P024);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N017);
    glVertex3fv(P017);
    glNormal3fv(N018);
    glVertex3fv(P018);
    glNormal3fv(N026);
    glVertex3fv(P026);
    glNormal3fv(N025);
    glVertex3fv(P025);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N013);
    glVertex3fv(P013);
    glNormal3fv(N014);
    glVertex3fv(P014);
    glNormal3fv(N022);
    glVertex3fv(P022);
    glNormal3fv(N021);
    glVertex3fv(P021);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N012);
    glVertex3fv(P012);
    glNormal3fv(N013);
    glVertex3fv(P013);
    glNormal3fv(N021);
    glVertex3fv(P021);
    glNormal3fv(N020);
    glVertex3fv(P020);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N018);
    glVertex3fv(P018);
    glNormal3fv(N019);
    glVertex3fv(P019);
    glNormal3fv(N027);
    glVertex3fv(P027);
    glNormal3fv(N026);
    glVertex3fv(P026);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N019);
    glVertex3fv(P019);
    glNormal3fv(N012);
    glVertex3fv(P012);
    glNormal3fv(N020);
    glVertex3fv(P020);
    glNormal3fv(N027);
    glVertex3fv(P027);
    glEnd;
End;

Procedure Whale005;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N022);
    glVertex3fv(P022);
    glNormal3fv(N023);
    glVertex3fv(P023);
    glNormal3fv(N031);
    glVertex3fv(P031);
    glNormal3fv(N030);
    glVertex3fv(P030);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N021);
    glVertex3fv(P021);
    glNormal3fv(N022);
    glVertex3fv(P022);
    glNormal3fv(N030);
    glVertex3fv(P030);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N021);
    glVertex3fv(P021);
    glNormal3fv(N030);
    glVertex3fv(P030);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N023);
    glVertex3fv(P023);
    glNormal3fv(N024);
    glVertex3fv(P024);
    glNormal3fv(N031);
    glVertex3fv(P031);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N024);
    glVertex3fv(P024);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glNormal3fv(N031);
    glVertex3fv(P031);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N024);
    glVertex3fv(P024);
    glNormal3fv(N025);
    glVertex3fv(P025);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N025);
    glVertex3fv(P025);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N020);
    glVertex3fv(P020);
    glNormal3fv(N021);
    glVertex3fv(P021);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N020);
    glVertex3fv(P020);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N027);
    glVertex3fv(P027);
    glNormal3fv(N020);
    glVertex3fv(P020);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N027);
    glVertex3fv(P027);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glNormal3fv(N035);
    glVertex3fv(P035);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N025);
    glVertex3fv(P025);
    glNormal3fv(N026);
    glVertex3fv(P026);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N026);
    glVertex3fv(P026);
    glNormal3fv(N034);
    glVertex3fv(P034);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N026);
    glVertex3fv(P026);
    glNormal3fv(N027);
    glVertex3fv(P027);
    glNormal3fv(N035);
    glVertex3fv(P035);
    glNormal3fv(N034);
    glVertex3fv(P034);
    glEnd;
End;

Procedure Whale006;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N092);
    glVertex3fv(P092);
    glNormal3fv(N093);
    glVertex3fv(P093);
    glNormal3fv(N094);
    glVertex3fv(P094);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N093);
    glVertex3fv(P093);
    glNormal3fv(N092);
    glVertex3fv(P092);
    glNormal3fv(N094);
    glVertex3fv(P094);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N092);
    glVertex3fv(P092);
    glNormal3fv(N091);
    glVertex3fv(P091);
    glNormal3fv(N095);
    glVertex3fv(P095);
    glNormal3fv(N094);
    glVertex3fv(P094);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N091);
    glVertex3fv(P091);
    glNormal3fv(N092);
    glVertex3fv(P092);
    glNormal3fv(N094);
    glVertex3fv(P094);
    glNormal3fv(N095);
    glVertex3fv(P095);
    glEnd;
End;

Procedure Whale007;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N030);
    glVertex3fv(P030);
    glNormal3fv(N031);
    glVertex3fv(P031);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glNormal3fv(N030);
    glVertex3fv(P030);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glNormal3fv(N029);
    glVertex3fv(P029);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N035);
    glVertex3fv(P035);
    glNormal3fv(N028);
    glVertex3fv(P028);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N035);
    glVertex3fv(P035);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glNormal3fv(N043);
    glVertex3fv(P043);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N034);
    glVertex3fv(P034);
    glNormal3fv(N035);
    glVertex3fv(P035);
    glNormal3fv(N043);
    glVertex3fv(P043);
    glNormal3fv(N042);
    glVertex3fv(P042);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N034);
    glVertex3fv(P034);
    glNormal3fv(N042);
    glVertex3fv(P042);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N042);
    glVertex3fv(P042);
    glNormal3fv(N041);
    glVertex3fv(P041);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N031);
    glVertex3fv(P031);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N032);
    glVertex3fv(P032);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glNormal3fv(N033);
    glVertex3fv(P033);
    glNormal3fv(N041);
    glVertex3fv(P041);
    glEnd;
End;

Procedure Whale008;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N042);
    glVertex3fv(P042);
    glNormal3fv(N043);
    glVertex3fv(P043);
    glNormal3fv(N051);
    glVertex3fv(P051);
    glNormal3fv(N050);
    glVertex3fv(P050);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N043);
    glVertex3fv(P043);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glNormal3fv(N051);
    glVertex3fv(P051);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N051);
    glVertex3fv(P051);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N041);
    glVertex3fv(P041);
    glNormal3fv(N042);
    glVertex3fv(P042);
    glNormal3fv(N050);
    glVertex3fv(P050);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N041);
    glVertex3fv(P041);
    glNormal3fv(N050);
    glVertex3fv(P050);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N036);
    glVertex3fv(P036);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glNormal3fv(N045);
    glVertex3fv(P045);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glNormal3fv(N041);
    glVertex3fv(P041);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glNormal3fv(N040);
    glVertex3fv(P040);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glNormal3fv(N047);
    glVertex3fv(P047);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N037);
    glVertex3fv(P037);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glNormal3fv(N045);
    glVertex3fv(P045);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glNormal3fv(N046);
    glVertex3fv(P046);
    glNormal3fv(N045);
    glVertex3fv(P045);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N038);
    glVertex3fv(P038);
    glNormal3fv(N039);
    glVertex3fv(P039);
    glNormal3fv(N047);
    glVertex3fv(P047);
    glNormal3fv(N046);
    glVertex3fv(P046);
    glEnd;
End;

Procedure Whale009;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N050);
    glVertex3fv(P050);
    glNormal3fv(N051);
    glVertex3fv(P051);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N051);
    glVertex3fv(P051);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glNormal3fv(N052);
    glVertex3fv(P052);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glNormal3fv(N045);
    glVertex3fv(P045);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N044);
    glVertex3fv(P044);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glNormal3fv(N052);
    glVertex3fv(P052);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glNormal3fv(N050);
    glVertex3fv(P050);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glNormal3fv(N057);
    glVertex3fv(P057);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glNormal3fv(N049);
    glVertex3fv(P049);
    glNormal3fv(N057);
    glVertex3fv(P057);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glNormal3fv(N057);
    glVertex3fv(P057);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N047);
    glVertex3fv(P047);
    glNormal3fv(N048);
    glVertex3fv(P048);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N047);
    glVertex3fv(P047);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glNormal3fv(N055);
    glVertex3fv(P055);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N045);
    glVertex3fv(P045);
    glNormal3fv(N046);
    glVertex3fv(P046);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N046);
    glVertex3fv(P046);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N046);
    glVertex3fv(P046);
    glNormal3fv(N047);
    glVertex3fv(P047);
    glNormal3fv(N055);
    glVertex3fv(P055);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glEnd;
End;

Procedure Whale010;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N080);
    glVertex3fv(P080);
    glNormal3fv(N081);
    glVertex3fv(P081);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N081);
    glVertex3fv(P081);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N087);
    glVertex3fv(P087);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glNormal3fv(N087);
    glVertex3fv(P087);
    glNormal3fv(N090);
    glVertex3fv(P090);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N081);
    glVertex3fv(P081);
    glNormal3fv(N080);
    glVertex3fv(P080);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N081);
    glVertex3fv(P081);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N085);
    glVertex3fv(P085);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N087);
    glVertex3fv(P087);
    glNormal3fv(N083);
    glVertex3fv(P083);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N087);
    glVertex3fv(P087);
    glNormal3fv(N077);
    glVertex3fv(P077);
    glNormal3fv(N090);
    glVertex3fv(P090);
    glEnd;
End;

Procedure Whale011;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N082);
    glVertex3fv(P082);
    glNormal3fv(N084);
    glVertex3fv(P084);
    glNormal3fv(N079);
    glVertex3fv(P079);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N084);
    glVertex3fv(P084);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N079);
    glVertex3fv(P079);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N079);
    glVertex3fv(P079);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N088);
    glVertex3fv(P088);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glNormal3fv(N088);
    glVertex3fv(P088);
    glNormal3fv(N089);
    glVertex3fv(P089);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N088);
    glVertex3fv(P088);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N089);
    glVertex3fv(P089);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N089);
    glVertex3fv(P089);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N086);
    glVertex3fv(P086);
    glNormal3fv(N084);
    glVertex3fv(P084);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N078);
    glVertex3fv(P078);
    glNormal3fv(N084);
    glVertex3fv(P084);
    glNormal3fv(N079);
    glVertex3fv(P079);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N084);
    glVertex3fv(P084);
    glNormal3fv(N082);
    glVertex3fv(P082);
    glNormal3fv(N079);
    glVertex3fv(P079);
    glEnd;
End;

Procedure Whale012;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glNormal3fv(N067);
    glVertex3fv(P067);
    glNormal3fv(N066);
    glVertex3fv(P066);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glNormal3fv(N052);
    glVertex3fv(P052);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N059);
    glVertex3fv(P059);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glNormal3fv(N067);
    glVertex3fv(P067);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glNormal3fv(N066);
    glVertex3fv(P066);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N058);
    glVertex3fv(P058);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glNormal3fv(N057);
    glVertex3fv(P057);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glNormal3fv(N057);
    glVertex3fv(P057);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N056);
    glVertex3fv(P056);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glNormal3fv(N055);
    glVertex3fv(P055);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glNormal3fv(N062);
    glVertex3fv(P062);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N053);
    glVertex3fv(P053);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glNormal3fv(N052);
    glVertex3fv(P052);
    glEnd;
End;

Procedure Whale013;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N066);
    glVertex3fv(P066);
    glNormal3fv(N067);
    glVertex3fv(P067);
    glNormal3fv(N096);
    glVertex3fv(P096);
    glNormal3fv(N097);
    glVertex3fv(P097);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N097);
    glVertex3fv(P097);
    glNormal3fv(N096);
    glVertex3fv(P096);
    glNormal3fv(N098);
    glVertex3fv(P098);
    glNormal3fv(N099);
    glVertex3fv(P099);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glNormal3fv(N066);
    glVertex3fv(P066);
    glNormal3fv(N097);
    glVertex3fv(P097);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N067);
    glVertex3fv(P067);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glNormal3fv(N096);
    glVertex3fv(P096);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N060);
    glVertex3fv(P060);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glNormal3fv(N096);
    glVertex3fv(P096);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N096);
    glVertex3fv(P096);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glNormal3fv(N098);
    glVertex3fv(P098);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glNormal3fv(N065);
    glVertex3fv(P065);
    glNormal3fv(N097);
    glVertex3fv(P097);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glNormal3fv(N097);
    glVertex3fv(P097);
    glNormal3fv(N099);
    glVertex3fv(P099);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P005);
    glVertex3fv(P006);
    glVertex3fv(P099);
    glVertex3fv(P098);
    glEnd;
End;

Procedure Whale014;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N062);
    glVertex3fv(P062);
    glNormal3fv(N004);
    glVertex3fv(P004);
    glNormal3fv(N005);
    glVertex3fv(P005);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P006);
    glVertex3fv(P005);
    glVertex3fv(P004);
    glVertex3fv(P008);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glNormal3fv(N006);
    glVertex3fv(P006);
    glNormal3fv(N008);
    glVertex3fv(P008);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glNormal3fv(N008);
    glVertex3fv(P008);
    glNormal3fv(N004);
    glVertex3fv(P004);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N062);
    glVertex3fv(P062);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glNormal3fv(N004);
    glVertex3fv(P004);
    glEnd;
End;

Procedure Whale015;
Begin
    glBegin(GL_POLYGON);
    glNormal3fv(N055);
    glVertex3fv(P055);
    glNormal3fv(N003);
    glVertex3fv(P003);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N003);
    glVertex3fv(P003);
    glNormal3fv(N055);
    glVertex3fv(P055);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N003);
    glVertex3fv(P003);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N003);
    glVertex3fv(P003);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N054);
    glVertex3fv(P054);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glNormal3fv(N062);
    glVertex3fv(P062);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glNormal3fv(N063);
    glVertex3fv(P063);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glEnd;
    glBegin(GL_POLYGON);
    glNormal3fv(N100);
    glVertex3fv(P100);
    glNormal3fv(N002);
    glVertex3fv(P002);
    glNormal3fv(N062);
    glVertex3fv(P062);
    glEnd;
End;

Procedure Whale016;
Begin
    glBegin(GL_POLYGON);
    glVertex3fv(P104);
    glVertex3fv(P105);
    glVertex3fv(P106);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P107);
    glVertex3fv(P108);
    glVertex3fv(P109);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P110);
    glVertex3fv(P111);
    glVertex3fv(P112);
    glVertex3fv(P113);
    glVertex3fv(P114);
    glVertex3fv(P115);
    glEnd;
    glBegin(GL_POLYGON);
    glVertex3fv(P116);
    glVertex3fv(P117);
    glVertex3fv(P118);
    glVertex3fv(P119);
    glVertex3fv(P120);
    glVertex3fv(P121);
    glEnd;
End;

Procedure DrawWhale(Var fish:fishRec);
Var
   seg0, seg1, seg2, seg3, seg4, seg5, seg6, seg7:Single;
   pitch, thrash, chomp:single;
Begin
    fish.htail := Round (fish.htail - Round(5.0 * fish.v)) Mod 360;

    thrash := 70.0 * fish.v;

    seg0 := 1.5 * thrash * sin((fish.htail) * RRAD);
    seg1 := 2.5 * thrash * sin((fish.htail + 10.0) * RRAD);
    seg2 := 3.7 * thrash * sin((fish.htail + 15.0) * RRAD);
    seg3 := 4.8 * thrash * sin((fish.htail + 23.0) * RRAD);
    seg4 := 6.0 * thrash * sin((fish.htail + 28.0) * RRAD);
    seg5 := 6.5 * thrash * sin((fish.htail + 35.0) * RRAD);
    seg6 := 6.5 * thrash * sin((fish.htail + 40.0) * RRAD);
    seg7 := 6.5 * thrash * sin((fish.htail + 55.0) * RRAD);

    pitch := fish.v * sin((fish.htail - 160.0) * RRAD);

    if (fish.v > 2.0) Then chomp := -(fish.v - 2.0) * 200.0
    Else chomp := 0.0;

    P012[1] := iP012[1] + seg5;
    P013[1] := iP013[1] + seg5;
    P014[1] := iP014[1] + seg5;
    P015[1] := iP015[1] + seg5;
    P016[1] := iP016[1] + seg5;
    P017[1] := iP017[1] + seg5;
    P018[1] := iP018[1] + seg5;
    P019[1] := iP019[1] + seg5;

    P020[1] := iP020[1] + seg4;
    P021[1] := iP021[1] + seg4;
    P022[1] := iP022[1] + seg4;
    P023[1] := iP023[1] + seg4;
    P024[1] := iP024[1] + seg4;
    P025[1] := iP025[1] + seg4;
    P026[1] := iP026[1] + seg4;
    P027[1] := iP027[1] + seg4;

    P028[1] := iP028[1] + seg2;
    P029[1] := iP029[1] + seg2;
    P030[1] := iP030[1] + seg2;
    P031[1] := iP031[1] + seg2;
    P032[1] := iP032[1] + seg2;
    P033[1] := iP033[1] + seg2;
    P034[1] := iP034[1] + seg2;
    P035[1] := iP035[1] + seg2;

    P036[1] := iP036[1] + seg1;
    P037[1] := iP037[1] + seg1;
    P038[1] := iP038[1] + seg1;
    P039[1] := iP039[1] + seg1;
    P040[1] := iP040[1] + seg1;
    P041[1] := iP041[1] + seg1;
    P042[1] := iP042[1] + seg1;
    P043[1] := iP043[1] + seg1;

    P044[1] := iP044[1] + seg0;
    P045[1] := iP045[1] + seg0;
    P046[1] := iP046[1] + seg0;
    P047[1] := iP047[1] + seg0;
    P048[1] := iP048[1] + seg0;
    P049[1] := iP049[1] + seg0;
    P050[1] := iP050[1] + seg0;
    P051[1] := iP051[1] + seg0;

    P009[1] := iP009[1] + seg6;
    P010[1] := iP010[1] + seg6;
    P075[1] := iP075[1] + seg6;
    P076[1] := iP076[1] + seg6;

    P001[1] := iP001[1] + seg7;
    P011[1] := iP011[1] + seg7;
    P068[1] := iP068[1] + seg7;
    P069[1] := iP069[1] + seg7;
    P070[1] := iP070[1] + seg7;
    P071[1] := iP071[1] + seg7;
    P072[1] := iP072[1] + seg7;
    P073[1] := iP073[1] + seg7;
    P074[1] := iP074[1] + seg7;

    P091[1] := iP091[1] + seg3 * 1.1;
    P092[1] := iP092[1] + seg3;
    P093[1] := iP093[1] + seg3;
    P094[1] := iP094[1] + seg3;
    P095[1] := iP095[1] + seg3 * 0.9;

    P099[1] := iP099[1] + chomp;
    P098[1] := iP098[1] + chomp;
    P064[1] := iP064[1] + chomp;
    P061[1] := iP061[1] + chomp;
    P097[1] := iP097[1] + chomp;
    P096[1] := iP096[1] + chomp;

    glPushMatrix;

    glRotatef(pitch, 1.0, 0.0, 0.0);

    glTranslatef(0.0, 0.0, 8000.0);

    glRotatef(180.0, 0.0, 1.0, 0.0);

    glScalef(3.0, 3.0, 3.0);

    glEnable(GL_CULL_FACE);

    Whale001;
    Whale002;
    Whale003;
    Whale004;
    Whale005;
    Whale006;
    Whale007;
    Whale008;
    Whale009;
    Whale010;
    Whale011;
    Whale012;
    Whale013;
    Whale014;
    Whale015;
    Whale016;

    glDisable(GL_CULL_FACE);

    glPopMatrix;
End;

End.

